#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include "sock.h"
#include "simfi.h"

int main(int argc,char **argv)
{
  char buf[1024];
  if (argc!=4) 
      exit(fprintf(stderr,"usage: %s host file remote-file\n",argv[0]));

  struct stat sbuf;
  int fd;
  int so;
  int len,mode,nl;

  fd= open(argv[2],O_RDONLY);
  if (fd<0) 
    exit(fprintf(stderr,"can't open %s: %s\n",argv[2],strerror(errno)));
  if (fstat(fd,&sbuf))
    exit(fprintf(stderr,"can't stat %s: %s\n",argv[2],strerror(errno)));

  so= sock_connect(argv[1], SIMFIPORT);
  if (so<0) exit(fprintf(stderr,"can't connect to %s:%d\n",argv[1],SIMFIPORT));

  len= sbuf.st_size;
  mode= sbuf.st_mode & 0777;
  nl= strlen(argv[3])+1;

  sprintf(buf,"%08x%08x%08x", len, mode, nl);
  if (sock_sendall(so,buf,24)) goto send_error;
  if (sock_sendall(so,argv[3],nl)) goto send_error;

  printf("Sending %s as %s\n",argv[2],argv[3]);
  int sent;
  sent= 0;
  while(sent<len)
  {
    int R;
    R= read(fd, buf, sizeof(buf));
    if (R<=0) { if (errno==EINTR) continue; 
                exit(fprintf(stderr,"error in read: %s\n",strerror(errno))); }
    if (sock_sendall(so,buf,R)) goto send_error;
    sent+= R;
    printf("\rsent %6d bytes           ",sent);
    fflush(stdout);
  }
  printf("\n");
  sock_close(so);
  close(fd);
  return 0;

send_error:
  exit(fprintf(stderr,"problem with send(), aborting\n"));
  return 1;
}

