#include <stdlib.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <netinet/in.h>
#include <err.h>
#include "sock.h"
#include "simfi.h"

int hexv(int A)
{
  if (A>='0' && A<='9') return A-'0';
  if (A>='a' && A<='f') return A-'a'+10;
  if (A>='A' && A<='F') return A-'A'+10;
  return 0;
}

int eightdigit(char *Z)
{
  int V;
  int i;
  V= 0;
  for(i=0;i<8;i++)
  {
    V= (V<<4) | hexv(Z[i]);
  }
  return V;
}

int eclose(int fd,int k)
{
  return close(fd);
}

int write_all(int fd,char *buf,int len)
{
  while(len)
  {
   int R;
   R= write(fd, buf,len);
   if (R<=0) 
   {
     if (errno==EINTR) continue;
     warn("write");
     return len;
   }
   buf+= R;
   len-= R;
  }
  return 0;
}

int serve_client(int so)
{
  char buf[1024];
  int fd;
  int len,mode,nl;

  printf("new connection\n");
  if (sock_recvall(so,buf,24)) 
    return fprintf(stderr, "read_header failed\n");

  len= eightdigit(buf);
  mode= eightdigit(buf+8);
  nl= eightdigit(buf+16);

  if (sock_recvall(so,buf,nl))
    return fprintf(stderr, "read_name failed\n");

  char *name;

  name= strdup(buf);

  fd= creat(name, mode);
  if (fd<0)
    return fprintf(stderr,"can't open %s: %s\n",name,strerror(errno));

  int got;
  got= 0;

  printf("Creating %s: %d bytes\n",name,len);
  while(got<len)
  {
    int R;
    R= recv(so, buf, sizeof(buf),0);
    if (R<=0)
    { 
      if (errno==EINTR) continue;
      return eclose(fd,fprintf(stderr,"error in receive: %s\n",strerror(errno)));
    }
    if (write_all(fd,buf,R))
      return eclose(fd, 
               fprintf(stderr,"error during write: %s\n",strerror(errno)));
    got+= R;
    printf("\rreceived %6d bytes       ", got);
    fflush(stdout);
  }
  printf("\n");

  close(fd);
  return 0;
}


int main(int argc,char **argv)
{
  int servso;

  servso= sock_create_server(SIMFIPORT);
  if (servso<0)
    exit(fprintf(stderr,"can't create socket: %s\n",strerror(errno)));

  while(1)
  {
    int cso;
    struct sockaddr_in cli;
    socklen_t clisiz;

    clisiz= sizeof(cli);
    cso= accept(servso, (struct sockaddr*) &cli, &clisiz);
    if (cso<0)
    {
       fprintf(stderr,"can't accept: %s\n",strerror(errno));
       sleep(1);
    }
    else { serve_client(cso); sock_close(cso); }
  }
  return 0;
}
